package com.mortals.xhx.module.operate.web;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.BizLogPdu;
import com.mortals.framework.model.OperateLogPdu;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.code.OperTypeEnum;
import com.mortals.xhx.common.utils.BeanUtil;
import com.mortals.xhx.system.MessageProducer;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.operate.model.OperateLogEntity;
import com.mortals.xhx.module.operate.service.OperateLogService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import static com.mortals.framework.ap.SysConstains.*;

/**
 * 平台用户操作日志业务
 *
 * @author zxfei
 * @date 2022-08-17
 */
@RestController
@RequestMapping("operate/log")
public class OperateLogController extends BaseCRUDJsonBodyMappingController<OperateLogService, OperateLogEntity, Long> {

    @Autowired
    private ParamService paramService;

    @Autowired
    private MessageProducer messageProducer;

    public OperateLogController() {
        super.setModuleDesc("平台用户操作日志业务");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "operType", OperTypeEnum.getEnumMap());
        this.addDict(model, "platformMark", paramService.getParamBySecondOrganize("OperateLog", "platformMark"));

        super.init(model, context);
    }

    @Override
    protected void doListBefore(OperateLogEntity query, Map<String, Object> model, Context context) throws AppException {
        List<OrderCol> orderColList = new ArrayList<>();
        orderColList.add(new OrderCol("id", OrderCol.DESCENDING));
        query.setOrderColList(orderColList);
        super.doListBefore(query, model, context);
    }

    @Override
    @UnAuth
    public String save(@RequestBody OperateLogEntity entity) {
        OperateLogPdu operateLogPdu = new OperateLogPdu();
        operateLogPdu.initAttrValue();
        BeanUtils.copyProperties(entity, operateLogPdu, BeanUtil.getNullPropertyNames(entity));
        messageProducer.syncOperSend(operateLogPdu);
        JSONObject ret = new JSONObject();
        ret.put("code", VALUE_RESULT_SUCCESS);
        return ret.toJSONString();

        //return super.save(entity);
    }

    public static void main(String[] args) throws JsonProcessingException {
        String json = "{\"content\":\"查询异常日志 【成功】\",\"ip\":\"192.168.0.57\",\"logDate\":1687249688260,\"loginName\":\"admin\",\"operType\":1,\"platformMark\":\"log-manager\",\"requestUrl\":\"/logservice/error/log/list\",\"userId\":1,\"userName\":\"系统管理员\"}";

        ObjectMapper objectMapper = new ObjectMapper();


        Object o = objectMapper.readValue(json, objectMapper.constructType(OperateLogEntity.class));

       // OperateLogEntity person = objectMapper.readValue(json, OperateLogEntity.class);

        System.out.println(o.toString());

    }
}